Description

Hi,

When I add a custom field to an enumeration and the custom field has the "Multiple values" option set, it is not possible to change

the custom value when editing the enumeration.

This is because with multiple values the POST parameter is an array, but that is not permitted in the EnumerationsController.

Here is a patch to fix this issue:

   def enumeration_params

     # can't require enumeration on #new action

-    cf_ids = @enumeration.available_custom_fields.map{|c| c.id.to_s}

+    cf_ids = @enumeration.available_custom_fields.map{|c| c.multiple? ? {c.id.to_s => []} : c.id.

to_s}

     params.permit(:enumeration => [:name, :active, :is_default, :position, :custom_field_values =

> cf_ids])[:enumeration]

   end

 end

 Best regards,

Thomas

Associated revisions

Revision 19588 - 2020-03-20 03:25 - Go MAEDA

Fix that unable to update the values of a custom field for time tracking activities when multiple values option is enabled (#33085).

Patch by Thomas Löber.

Revision 19589 - 2020-03-20 03:31 - Go MAEDA

Test for r19588 (#33085).

Patch by Mizuki ISHIKAWA.

Revision 19590 - 2020-03-20 03:35 - Go MAEDA

Merged r19588 and r19589 from trunk to 4.1-stable (#33085).

Revision 19591 - 2020-03-20 03:37 - Go MAEDA

Merged r19588 and r19589 from trunk to 4.0-stable (#33085).

History

#1 - 2020-03-08 00:09 - Go MAEDA

- File Screenshot_2020-03-08.png added

- Status changed from New to Confirmed

I have confirmed that values for a custom field of time tracking activities cannot be saved if "Multiple values" option is enabled.
#2 - 2020-03-09 06:43 - Mizuki ISHIKAWA

- File add_test.patch added

Thomas Löber wrote:

Here is a patch to fix this issue:

[...]

 I have confirmed that the code you wrote in descriptipn solves this problem.

To permit an array value of strong_parameters, it is necessary to set an empty array, so {c.id.to_s => []} is set when c.multiple? is true.

The attached patch adds a test to the code written by Thomas Löber.

#3 - 2020-03-09 07:31 - Go MAEDA

- Target version set to Candidate for next minor release

#4 - 2020-03-09 14:16 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.0.7

Setting the target version to 4.0.7.

#5 - 2020-03-20 03:32 - Go MAEDA

- Subject changed from Cannot use custom fields with multiple values in enumerations to Unable to update the values of a custom field for

enumerations when multiple values option is enabled

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patches. Thank you for providing the fix.

#6 - 2020-03-20 03:37 - Go MAEDA

- Status changed from Resolved to Closed

Files

Screenshot_2020-03-08.png 31.6 KB 2020-03-07 Go MAEDA

add_test.patch 1.18 KB 2020-03-09 Mizuki ISHIKAWA
